{ "error": { "code": "BAD_REQUEST_ERROR", "description": "Different request with the same idempotency key has already been processed.", "source": "NA", "step": "NA", "reason": "NA", "metadata": {} }}
Available in🇮🇳 India🇲🇾 Malaysia
Idempotency allows you to safely retry or send the same request multiple times without fear of repeating the normal refund request more than once.
When you try to create a normal refund, in some cases due to network downtimes, you may not get a response from our servers. As a consequence, you will not be aware of the refund id or its state. In such cases, you can safely retry the transaction using the same idempotency key without risk of double-refund or duplication.
To make a normal refund request idempotent, add the header X-Refund-Idempotency to the request and pass an idempotency key against it. The idempotency key must be at least 10 character long and can contain alphabets, numbers, hyphens and underscores only. For example, 550e8400-e29b-41d4-a716-446655440000.
Idempotency is supported for both Normal and Instant Refunds APIs.
Handy Tips
When retrying a request, the request body must be the same as the first request for idempotency to work. A different payload will be rejected as a BAD_REQUEST.
The idempotency key in retries must be the same as the original request.
Use unique idempotency keys for each unique request.
If a request is received while a prior request is still being processed, the system will return a 409 Conflict status code. You may retry the request upon receiving this response.
The amount to be refunded. Amount should be in the smallest unit of the currency in which the payment was made. In the case of three decimal currencies, such as KWD, BHD and OMR, to refund a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to refund a payment of 295, pass the value as 295.
For a partial refund, enter a value lesser than the payment amount. For example, if the payment amount is ₹1500 and you want to refund only ₹500, you must pass 50000.
For full refund, enter the entire payment amount. If the amount parameter is not passed, the entire payment amount will be refunded.
Watch Out!As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to refund a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as 99990 and not 99991.
The speed at which the refund is to be processed. The default value is normal. Refund will be processed via the normal speed, and the customer will receive the refund within 5-7 working days.
A dynamic array consisting of a unique reference number (either RRN, ARN or UTR) that is provided by the banking partner when a refund is processed. This reference number can be used by the customer to track the status of the refund with the bank.
The processing mode of the refund seen in the refund response. This attribute is seen in the refund response only if the speed parameter is set in the refund request. Possible values:
normal: Indicates that the refund will be processed via the normal speed. The refund will take 5-7 working days.
optimum: Indicates that the refund will be processed at an optimal speed based on Razorpay’s internal fund transfer logic.
If the refund can be processed instantly, Razorpay will do so, irrespective of the payment method used to make the payment.
If an instant refund is not possible, Razorpay will initiate a refund that is processed at the normal speed.
This is a parameter in the response which describes the mode used to process a refund. This attribute is seen in the refund response only if the speed parameter is set in the refund request. Possible values:
instant: Indicates that the refund has been processed instantly via fund transfer.
normal: Indicates that the refund has been processed by the payment processing partner. The refund will take 5-7 working days.
Code:4xxThe API credentials passed in the API call differ from the ones generated on the Dashboard.Solution: The API keys must be active and entered correctly with no whitespace before or after.
{Payment_id} is not a valid id.
Code:400The payment_id provided is invalid.Solution: Use a valid payment_id.
The requested URL was not found on the server.
Code:400Possible reasons:
The URL is wrong or is missing something.
A POST API is executed by GET method.
Solution:
Ensure that the URL is correct and complete.
Use the correct method, that is, POST.
{any Extra field} is/are not required and should not be sent.
Code:400An additional or unrequired parameter is passed.Solution: Ensure that you only pass the required parameters in the request body.
The refund amount provided is greater than amount captured.
Code:400The refund amount entered is more than the amount captured.Solution: Enter an amount equal to or less than the amount captured.
The amount must be at least INR 1.00.
Code:400The refund amount entered is less than .Solution: Enter an amount of at least .
The payment has been fully refunded already.
Code:400The payment_id has already been refunded fully.Solution: Use a payment_id that has not been fully refunded.
Different request with the same idempotency key has already been processed.
Code:409Another refund request with different parameters has been processed using the same idempotency key.Solution: Use a unique idempotency key for the new request and retry.
Another request with the same idempotency key is still in progress.
Code:409A refund request with the same idempotency key is currently being processed and has not yet returned a response.Solution: Wait for the previous request to complete or use a different idempotency key.
Internal server error - Failed to fetch idempotency record
Code:500The server encountered an error while retrieving the idempotency record.Solution: Retry the request after some time. If the issue persists, contact Razorpay Support.
Internal server error - Failed to parse request body
Code:500The server failed to parse the request body to generate the request hash.Solution: Ensure the request body is properly formatted as valid JSON. If the issue persists, contact Razorpay Support.
The idempotency key must be at least 10 characters long.
Code:400The idempotency key provided is less than 10 characters in length.Solution: Use an idempotency key that is at least 10 characters long.
The idempotency key must only contain alphanumeric characters, underscores, and hyphens
Code:400The idempotency key contains invalid special characters.Solution: Ensure the idempotency key only contains alphanumeric characters (A-Z, a-z, 0-9), underscores (_), and hyphens (-).
Merchant id not found in authentication
Code:500The request contains an idempotency key but the merchant authentication is invalid or missing.Solution: Ensure you are using valid API credentials (Key ID and Key Secret) for authentication. If the issue persists, contact Razorpay Support.
Was this page helpful?
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"Razorpay","colors":{"primary":"#3395FF","light":"#66B2FF","dark":"#0B62C4"},"logo":{"light":"https://mintcdn.com/razorpay-881012b3/puuu1wI-BbW3rsp2/logo/light.svg?fit=max\u0026auto=format\u0026n=puuu1wI-BbW3rsp2\u0026q=85\u0026s=e0750375ee2004193a685f9f211963fe","dark":"https://mintcdn.com/razorpay-881012b3/puuu1wI-BbW3rsp2/logo/dark.svg?fit=max\u0026auto=format\u0026n=puuu1wI-BbW3rsp2\u0026q=85\u0026s=038b180f26d19ddb4eb40ede0cf84821","href":"https://razorpay.com/docs/"},"favicon":"https://mintcdn.com/razorpay-881012b3/puuu1wI-BbW3rsp2/favicon.png?fit=max\u0026auto=format\u0026n=puuu1wI-BbW3rsp2\u0026q=85\u0026s=9bebe786d3a21e9452fd2e31243e5fb3","api":{"playground":{"display":"interactive"},"mdx":{"auth":{"method":"basic"},"server":"https://api.razorpay.com"}},"navbar":{"links":[{"href":"https://razorpay.com/support/","label":"Support"},{"href":"https://razorpay.com/blog/","label":"Blog"}],"primary":{"type":"button","label":"Dashboard","href":"https://dashboard.razorpay.com/"}},"footer":{"socials":{"x":"https://x.com/Razorpay","linkedin":"https://www.linkedin.com/company/razorpay","github":"https://github.com/razorpay","youtube":"https://www.youtube.com/razorpay"},"links":[{"header":"Products","items":[{"label":"Payment Gateway","href":"https://razorpay.com/payment-gateway"},{"label":"Payment Links","href":"https://razorpay.com/payment-links"},{"label":"RazorpayX","href":"https://razorpay.com/x"},{"label":"Payroll","href":"https://razorpay.com/payroll"}]},{"header":"Resources","items":[{"label":"Documentation","href":"https://razorpay.com/docs"},{"label":"API Reference","href":"https://razorpay.com/docs/api"},{"label":"Support","href":"https://razorpay.com/support"},{"label":"Blog","href":"https://razorpay.com/blog"}]},{"header":"Company","items":[{"label":"About Us","href":"https://razorpay.com/about"},{"label":"Careers","href":"https://razorpay.com/jobs"},{"label":"Pricing","href":"https://razorpay.com/pricing"}]}]},"seo":{"metatags":{"canonical":"https://razorpay.com"}},"contextual":{"options":["copy","view","chatgpt","claude","perplexity","mcp","cursor","vscode"],"display":"header"},"styling":{"latex":true},"navigation":{"pages":[]}},"deployment":{"deploymentMetadataValue":{"subdomain":"razorpay-881012b3","hasAudioNarration":false,"actualSubdomain":"razorpay-881012b3","customDomains":["razorpay.com"],"gitSource":{"type":"github","owner":"razorpay-vendor-integrations","repo":"docs","deployBranch":"main","contentDirectory":"","isPrivate":true,"mountPath":"","label":""},"chroma":{"latestBuiltDeploymentHistoryId":"6ae2e2f12acb2a9bf04bbd89","collectionId":"1723ddf4-e7d6-4ac5-943e-8cc1bb15c263","liveDeploymentHistoryId":"6ae2e2f12acb2a9bf04bbd89","schemaVersion":"v3"},"feedback":{"thumbs":true,"agentFeedback":true},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"REMOVE_BRANDING":{"status":"ENABLED"},"CONTEXTUAL_FEEDBACK":{"status":"ENABLED"},"CODE_SNIPPET_FEEDBACK":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6ae2e2f12acb2a9bf04bbd89","clientVersion":"0.0.4006","searchFilterCounts":[{"language":"default","tag":"Payments","count":1644},{"language":"default","tag":"API Reference","count":774},{"language":"default","tag":"Payment Gateway","count":236},{"language":"default","tag":"Dashboard","count":213},{"language":"default","tag":"Subscriptions","count":190},{"language":"default","tag":"Payouts","count":160},{"language":"default","tag":"Payment Links","count":129},{"language":"default","tag":"Banking Plus","count":123},{"language":"default","tag":"Developer Tools","count":104},{"language":"default","tag":"Ecommerce Plugins","count":104}],"searchSettings":{"maxResults":8}},"assistantConfig":{"enableAskAiButton":false,"enableStarterQuestions":false,"enableContextualStarterQuestions":false,"enableAskAiSearchBar":true},"basePath":"/docs","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"pause-universal-search-reconcile","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"per-site-search-delta","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-private-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"byok-sep-25","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"vite-origin","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-updated-9-15","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"googleFontsInlined":false},"customCss":[{"filePath":"style.css","content":"#navbar ul.sidebar-group.mt-6,ul.sidebar-group.mt-6{margin-top:1rem}[data-component-part=callout-content]>[data-as=p]:first-child strong,[data-component-part=callout-content]>[data-as=p]:first-child>strong,[data-component-part=callout-content]>strong:first-child{font-size:1.125rem!important;font-weight:700!important;line-height:1.4!important}.error-code-cards [data-component-part=card-title]{display:inline-block!important;font-family:ui-monospace,\"SF Mono\",SFMono-Regular,Menlo,Consolas,\"Liberation Mono\",monospace!important;font-size:.875rem!important;font-weight:600!important;line-height:1.3!important;padding:.25rem .75rem!important;border-radius:9999px!important;background:rgba(107,114,128,.1)!important;border:1px solid rgba(107,114,128,.25)!important}.dark .error-code-cards [data-component-part=card-title]{background:rgba(255,255,255,.06)!important;border-color:rgba(255,255,255,.15)!important}[data-http-method]{font-weight:700!important;border-color:transparent!important}[data-http-method=get]{color:#15803d!important;background:rgba(74,222,128,.2)!important}[data-http-method=post]{color:#1d4ed8!important;background:rgba(96,165,250,.2)!important}[data-http-method=put]{color:#a16207!important;background:rgba(250,204,21,.2)!important}[data-http-method=patch]{color:#c2410c!important;background:rgba(251,146,60,.2)!important}[data-http-method=delete]{color:#b91c1c!important;background:rgba(248,113,113,.2)!important}.dark [data-http-method=get]{color:#4ade80!important}.dark [data-http-method=post]{color:#60a5fa!important}.dark [data-http-method=put]{color:#facc15!important}.dark [data-http-method=patch]{color:#fb923c!important}.dark [data-http-method=delete]{color:#f87171!important}ul.sidebar-group.mt-6{margin-top:5px}.sticky .panel:has(>.rzp-code-selector){display:grid;grid-auto-rows:minmax(0,1fr);gap:1.5rem;overflow:hidden}.sticky:has(>.panel>.rzp-code-selector)>div:not(.panel){display:none}.rzp-code-selector{position:relative;display:flex;flex-direction:column;min-height:0;overflow:hidden;padding:.125rem;border:1px solid rgba(3,7,18,.1);border-radius:1rem;background:#f4f7fa}.dark .rzp-code-selector{border-color:rgba(255,255,255,.1);background:rgba(255,255,255,.05)}.rzp-code-selector-bar{display:flex;align-items:center;justify-content:space-between;gap:.5rem;flex:none;flex-wrap:wrap;padding:.25rem 4.25rem .375rem .5rem}.rzp-code-selector-field{position:relative;display:inline-flex;align-items:center;flex:0 0 auto}.rzp-code-selector-select{appearance:none;-webkit-appearance:none;min-width:max-content;padding:.125rem 1.75rem .125rem .375rem;border:0;border-radius:.5rem;background:0 0;color:var(--color-gray-600, #4b5563);font-size:.75rem;font-weight:500;line-height:1.5rem;cursor:pointer}.dark .rzp-code-selector-select{color:var(--color-gray-300, #d1d5db)}.rzp-code-selector-select:hover{background:rgba(3,7,18,.05)}.dark .rzp-code-selector-select:hover{background:rgba(255,255,255,.08)}.rzp-code-selector-chevron{position:absolute;right:.25rem;width:.875rem;height:.875rem;pointer-events:none;opacity:.6}.rzp-code-selector-body{flex:1 1 auto;min-height:0;overflow-y:auto;overscroll-behavior:contain}.rzp-code-selector-body>.code-block{margin:0!important;min-width:0;border-radius:0 0 .875rem .875rem;position:static!important}.rzp-code-selector-body [data-component-part=code-block-root],.rzp-code-selector::after{border-radius:0 0 .875rem .875rem}.rzp-code-selector-body .code-block-fade-overlay{display:none}.rzp-code-selector::after{content:\"\";position:absolute;inset:auto 0 0;height:2rem;pointer-events:none;background:linear-gradient(to bottom,rgba(255,255,255,0),#fff)}.dark .rzp-code-selector::after{background:linear-gradient(to bottom,rgba(11,12,14,0),#0b0c0e)}.rzp-code-selector>.rzp-code-selector-body>.code-block>.absolute{top:.5rem;right:.75rem}"},{"filePath":"static/docs-home/hide-navbar-on-home.css","content":"html[data-page-mode=custom] header#navbar{display:none!important}html[data-page-mode=custom] .pt-\\[120px\\]{padding-top:0!important}"},{"filePath":"static/docs-home/styles.css","href":"/docs/_mintlify/custom/razorpay-881012b3/f701d0604b2ed263/static/docs-home/styles.css"}],"page":{"pagePath":"api/refunds/normal-refunds-idempotent","slug":"/api/refunds/normal-refunds-idempotent","pageMetadata":{"title":"Create a Normal Refund (Idempotent Request)","description":"Retry or send the same normal refund request multiple times safely using the Razorpay API.","api":"POST /v1/payments/:id/refund","href":"/api/refunds/normal-refunds-idempotent"},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsx(_components.p, {\n children: \"Retry or send the same normal refund request multiple times safely using the Razorpay API.\"\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,li:`li`,p:`p`,strong:`strong`,ul:`ul`,..._provideComponents(),...props.components},{Accordion,AccordionGroup,Heading,Info,ParamField,ResponseField,Warning}=_components;if(!Accordion)_missingMdxReference(`Accordion`,true);if(!AccordionGroup)_missingMdxReference(`AccordionGroup`,true);if(!Heading)_missingMdxReference(`Heading`,true);if(!Info)_missingMdxReference(`Info`,true);if(!ParamField)_missingMdxReference(`ParamField`,true);if(!ResponseField)_missingMdxReference(`ResponseField`,true);if(!Warning)_missingMdxReference(`Warning`,true);return _jsxs(_Fragment,{children:[_jsxs(`div`,{style:{display:`flex`,flexWrap:`wrap`,alignItems:`center`,gap:`0.35rem 0.9rem`,border:`1px solid rgba(128,128,128,0.28)`,borderRadius:`0.5rem`,padding:`0.45rem 0.75rem`,margin:`0 0 1.25rem`,fontSize:`0.875rem`},children:[_jsx(`span`,{style:{fontWeight:600},children:`Available in`}),_jsx(`span`,{children:`🇮🇳 India`}),_jsx(`span`,{children:`🇲🇾 Malaysia`})]}),`\n`,_jsx(_components.p,{children:`Idempotency allows you to safely retry or send the same request multiple times without fear of repeating the normal refund request more than once.`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`When you try to create a normal refund, in some cases due to network downtimes, you may not get a response from our servers. As a consequence, you will not be aware of the refund id or its state. In such cases, you can safely retry the transaction using the same idempotency key without risk of double-refund or duplication.`}),`\n`,_jsxs(_components.li,{children:[`To make a normal refund request idempotent, add the header `,_jsx(_components.code,{children:`X-Refund-Idempotency`}),` to the request and pass an idempotency key against it. The idempotency key must be at least 10 character long and can contain alphabets, numbers, hyphens and underscores only. For example, `,_jsx(_components.code,{children:`550e8400-e29b-41d4-a716-446655440000`}),`.`]}),`\n`,_jsx(_components.li,{children:`Idempotency is supported for both Normal and Instant Refunds APIs.`}),`\n`]}),`\n`,_jsxs(Info,{children:[_jsx(_components.p,{children:_jsx(_components.strong,{children:`Handy Tips`})}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`When retrying a request, the request body must be the same as the first request for idempotency to work. A different payload will be rejected as a `,_jsx(_components.code,{children:`BAD_REQUEST`}),`.`]}),`\n`,_jsx(_components.li,{children:`The idempotency key in retries must be the same as the original request.`}),`\n`,_jsx(_components.li,{children:`Use unique idempotency keys for each unique request.`}),`\n`,_jsx(_components.li,{children:`If a request is received while a prior request is still being processed, the system will return a 409 Conflict status code. You may retry the request upon receiving this response.`}),`\n`]})]}),`\n`,`\n`,`\n`,_jsx(Heading,{level:`2`,id:`path-parameters`,children:`Path Parameters`}),`\n`,_jsx(ParamField,{path:`id`,type:`string`,required:true,id:`param-id`,children:_jsx(_components.p,{children:`The unique identifier of the payment which needs to be refunded.`})}),`\n`,_jsx(Heading,{level:`2`,id:`request-parameters`,children:`Request Parameters`}),`\n`,_jsxs(ParamField,{body:`amount`,type:`integer`,id:`param-amount`,children:[_jsxs(_components.p,{children:[`The amount to be refunded. Amount should be in the smallest unit of the currency in which the payment was made. In the case of three decimal currencies, such as KWD, BHD and OMR, to refund a payment of 295.991, pass the value as `,_jsx(_components.code,{children:`295990`}),`. And in the case of zero decimal currencies such as JPY, to refund a payment of 295, pass the value as `,_jsx(_components.code,{children:`295`}),`.`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`For a `,_jsx(_components.strong,{children:`partial refund`}),`, enter a value lesser than the payment amount. For example, if the payment amount is ₹1500 and you want to refund only ₹500, you must pass `,_jsx(_components.code,{children:`50000`}),`.`]}),`\n`,_jsxs(_components.li,{children:[`For `,_jsx(_components.strong,{children:`full refund`}),`, enter the entire payment amount. If the `,_jsx(_components.code,{children:`amount`}),` parameter is not passed, the entire payment amount will be refunded.`]}),`\n`]}),_jsxs(Warning,{children:[_jsx(_components.p,{children:_jsx(_components.strong,{children:`Watch Out!`})}),_jsxs(_components.p,{children:[`As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to refund a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as `,_jsx(_components.code,{children:`99990`}),` and not `,_jsx(_components.code,{children:`99991`}),`.`]})]})]}),`\n`,_jsx(ParamField,{body:`speed`,type:`string`,id:`param-speed`,children:_jsxs(_components.p,{children:[`The speed at which the refund is to be processed. The default value is `,_jsx(_components.code,{children:`normal`}),`. Refund will be processed via the normal speed, and the customer will receive the refund within 5-7 working days.`]})}),`\n`,_jsx(ParamField,{body:`notes`,type:`json object`,id:`param-notes`,children:_jsx(_components.p,{children:`Key-value pairs used to store additional information. A maximum of 15 key-value pairs can be included.`})}),`\n`,_jsx(ParamField,{body:`receipt`,type:`string`,id:`param-receipt`,children:_jsx(_components.p,{children:`A unique identifier provided by you for your internal reference.`})}),`\n`,_jsx(Heading,{level:`2`,id:`response-parameters`,children:`Response Parameters`}),`\n`,_jsx(ResponseField,{name:`id`,type:`string`,id:`param-id-1`,children:_jsxs(_components.p,{children:[`The unique identifier of the refund. For example, `,_jsx(_components.code,{children:`rfnd_FgRAHdNOM4ZVbO`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`entity`,type:`string`,id:`param-entity`,children:_jsxs(_components.p,{children:[`Indicates the type of entity. Here, it is `,_jsx(_components.code,{children:`refund`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`amount`,type:`integer`,id:`param-amount-1`,children:_jsxs(_components.p,{children:[`The amount to be refunded (in the smallest unit of currency). `,_jsx(`br`,{}),` For example, if the refund value is ₹30 it will be `,_jsx(_components.code,{children:`3000`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`currency`,type:`string`,id:`param-currency`,children:_jsxs(_components.p,{children:[`The currency of payment amount for which the refund is initiated. Check the list of `,_jsx(_components.a,{href:`/payments/international-payments#supported-currencies`,children:`supported currencies`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`payment_id`,type:`string`,id:`param-payment-id`,children:_jsxs(_components.p,{children:[`The unique identifier of the payment for which a refund is initiated. For example, `,_jsx(_components.code,{children:`pay_FgR9UMzgmKDJRi`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`created_at`,type:`integer`,id:`param-created-at`,children:_jsxs(_components.p,{children:[`Unix timestamp at which the refund was created. For example, `,_jsx(_components.code,{children:`1600856650`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`batch_id`,type:`string`,id:`param-batch-id`,children:_jsxs(_components.p,{children:[`This parameter is populated if the refund was created as part of a batch upload. For example, `,_jsx(_components.code,{children:`batch_00000000000001`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`notes`,type:`json object`,id:`param-notes-1`,children:_jsxs(_components.p,{children:[`Key-value store for storing your reference data. A maximum of 15 key-value pairs can be included. For example, `,_jsx(_components.code,{children:`\"note_key\": \"Beam me up Scotty\"`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`receipt`,type:`string`,id:`param-receipt-1`,children:_jsx(_components.p,{children:`A unique identifier provided by you for your internal reference.`})}),`\n`,_jsx(ResponseField,{name:`acquirer_data`,type:`array`,id:`param-acquirer-data`,children:_jsx(_components.p,{children:`A dynamic array consisting of a unique reference number (either RRN, ARN or UTR) that is provided by the banking partner when a refund is processed. This reference number can be used by the customer to track the status of the refund with the bank.`})}),`\n`,_jsxs(ResponseField,{name:`status`,type:`string`,id:`param-status`,children:[_jsx(_components.p,{children:`Indicates the state of the refund. Possible values:`}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`pending`}),`: This state indicates that Razorpay is attempting to process the refund.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`processed`}),`: This is the final state of the refund.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`failed`}),`: A refund can attain the failed state in the following scenarios:`,_jsx(`br`,{}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`Normal refund is not possible for a payment which is more than 6 months old.`,_jsx(`br`,{})]}),`\n`,_jsx(_components.li,{children:`Instant Refund can sometimes fail because of customer’s account or bank-related issues.`}),`\n`]}),`\n`]}),`\n`]})]}),`\n`,_jsxs(ResponseField,{name:`speed_requested`,type:`string`,id:`param-speed-requested`,children:[_jsxs(_components.p,{children:[`The processing mode of the refund seen in the refund response. `,_jsx(`br`,{}),` This attribute is seen in the refund response only if the `,_jsx(_components.code,{children:`speed`}),` parameter is set in the refund request.`,_jsx(`br`,{}),`Possible values:`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`normal`}),`: Indicates that the refund will be processed via the normal speed. The refund will take 5-7 working days.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`optimum`}),`: Indicates that the refund will be processed at an optimal speed based on Razorpay’s internal fund transfer logic.`,`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`If the refund can be processed instantly, Razorpay will do so, irrespective of the payment method used to make the payment.`}),`\n`,_jsx(_components.li,{children:`If an instant refund is not possible, Razorpay will initiate a refund that is processed at the normal speed.`}),`\n`]}),`\n`]}),`\n`]})]}),`\n`,_jsxs(ResponseField,{name:`speed_processed`,type:`string`,id:`param-speed-processed`,children:[_jsxs(_components.p,{children:[`This is a parameter in the response which describes the mode used to process a refund. `,_jsx(`br`,{}),` This attribute is seen in the refund response only if the `,_jsx(_components.code,{children:`speed`}),` parameter is set in the refund request. Possible values:`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`instant`}),`: Indicates that the refund has been processed instantly via fund transfer.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`normal`}),`: Indicates that the refund has been processed by the payment processing partner. The refund will take 5-7 working days.`]}),`\n`]})]}),`\n`,_jsx(Heading,{level:`2`,id:`errors`,children:`Errors`}),`\n`,_jsxs(AccordionGroup,{children:[_jsxs(Accordion,{title:`The API {key/secret} provided is invalid.`,id:`the-api-key-secret-provided-is-invalid`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`4xx`})]}),_jsx(_components.p,{children:`The API credentials passed in the API call differ from the ones generated on the Dashboard.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` The API keys must be active and entered correctly with no whitespace before or after.`]})]}),_jsxs(Accordion,{title:`{Payment_id} is not a valid id.`,id:`payment-id-is-not-a-valid-id`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsxs(_components.p,{children:[`The `,_jsx(_components.code,{children:`payment_id`}),` provided is invalid.`]}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use a valid `,_jsx(_components.code,{children:`payment_id`}),`.`]})]}),_jsxs(Accordion,{title:`The requested URL was not found on the server.`,id:`the-requested-url-was-not-found-on-the-server`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`Possible reasons:`}),_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`The URL is wrong or is missing something.`}),`\n`,_jsx(_components.li,{children:`A POST API is executed by GET method.`}),`\n`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`Solution:`})}),_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`Ensure that the URL is correct and complete.`}),`\n`,_jsx(_components.li,{children:`Use the correct method, that is, POST.`}),`\n`]})]}),_jsxs(Accordion,{title:`{any Extra field} is/are not required and should not be sent.`,id:`any-extra-field-is-are-not-required-and-should-not-be-sent`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`An additional or unrequired parameter is passed.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure that you only pass the required parameters in the request body.`]})]}),_jsxs(Accordion,{title:`The refund amount provided is greater than amount captured.`,id:`the-refund-amount-provided-is-greater-than-amount-captured`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The refund amount entered is more than the amount captured.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Enter an amount equal to or less than the amount captured.`]})]}),_jsxs(Accordion,{title:_jsx(_Fragment,{children:`The amount must be at least INR 1.00.`}),id:`the-amount-must-be-at-least-inr-1-00`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The refund amount entered is less than .`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Enter an amount of at least .`]})]}),_jsxs(Accordion,{title:`The payment has been fully refunded already.`,id:`the-payment-has-been-fully-refunded-already`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsxs(_components.p,{children:[`The `,_jsx(_components.code,{children:`payment_id`}),` has already been refunded fully.`]}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use a `,_jsx(_components.code,{children:`payment_id`}),` that has not been fully refunded.`]})]}),_jsxs(Accordion,{title:`Different request with the same idempotency key has already been processed.`,id:`different-request-with-the-same-idempotency-key-has-already-been-processed`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`409`})]}),_jsx(_components.p,{children:`Another refund request with different parameters has been processed using the same idempotency key.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use a unique idempotency key for the new request and retry.`]})]}),_jsxs(Accordion,{title:`Another request with the same idempotency key is still in progress.`,id:`another-request-with-the-same-idempotency-key-is-still-in-progress`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`409`})]}),_jsx(_components.p,{children:`A refund request with the same idempotency key is currently being processed and has not yet returned a response.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Wait for the previous request to complete or use a different idempotency key.`]})]}),_jsxs(Accordion,{title:`Internal server error - Failed to fetch idempotency record`,id:`internal-server-error-failed-to-fetch-idempotency-record`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`500`})]}),_jsx(_components.p,{children:`The server encountered an error while retrieving the idempotency record.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Retry the request after some time. If the issue persists, contact `,_jsx(_components.a,{href:`https://razorpay.com/support`,children:`Razorpay Support`}),`.`]})]}),_jsxs(Accordion,{title:`Internal server error - Failed to parse request body`,id:`internal-server-error-failed-to-parse-request-body`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`500`})]}),_jsx(_components.p,{children:`The server failed to parse the request body to generate the request hash.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure the request body is properly formatted as valid JSON. If the issue persists, contact `,_jsx(_components.a,{href:`https://razorpay.com/support`,children:`Razorpay Support`}),`.`]})]}),_jsxs(Accordion,{title:`The idempotency key must be at least 10 characters long.`,id:`the-idempotency-key-must-be-at-least-10-characters-long`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The idempotency key provided is less than 10 characters in length.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use an idempotency key that is at least 10 characters long.`]})]}),_jsxs(Accordion,{title:`The idempotency key must only contain alphanumeric characters, underscores, and hyphens`,id:`the-idempotency-key-must-only-contain-alphanumeric-characters-underscores-and-hyphens`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The idempotency key contains invalid special characters.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure the idempotency key only contains alphanumeric characters (A-Z, a-z, 0-9), underscores (_), and hyphens (-).`]})]}),_jsxs(Accordion,{title:`Merchant id not found in authentication`,id:`merchant-id-not-found-in-authentication`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`500`})]}),_jsx(_components.p,{children:`The request contains an idempotency key but the merchant authentication is invalid or missing.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure you are using valid API credentials (Key ID and Key Secret) for authentication. If the issue persists, contact `,_jsx(_components.a,{href:`https://razorpay.com/support`,children:`Razorpay Support`}),`.`]})]})]})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Create a Normal Refund (Idempotent Request)","description":"Retry or send the same normal refund request multiple times safely using the Razorpay API.","api":"POST /v1/payments/:id/refund","href":"/api/refunds/normal-refunds-idempotent"}}},"mdxSourceWithNoJs":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,li:`li`,p:`p`,pre:`pre`,span:`span`,strong:`strong`,ul:`ul`,..._provideComponents(),...props.components},{Accordion,AccordionGroup,CodeBlock,Heading,Info,ParamField,RequestExample,ResponseExample,ResponseField,Warning}=_components;if(!Accordion)_missingMdxReference(`Accordion`,true);if(!AccordionGroup)_missingMdxReference(`AccordionGroup`,true);if(!CodeBlock)_missingMdxReference(`CodeBlock`,true);if(!Heading)_missingMdxReference(`Heading`,true);if(!Info)_missingMdxReference(`Info`,true);if(!ParamField)_missingMdxReference(`ParamField`,true);if(!RequestExample)_missingMdxReference(`RequestExample`,true);if(!ResponseExample)_missingMdxReference(`ResponseExample`,true);if(!ResponseField)_missingMdxReference(`ResponseField`,true);if(!Warning)_missingMdxReference(`Warning`,true);return _jsxs(_Fragment,{children:[_jsxs(`div`,{style:{display:`flex`,flexWrap:`wrap`,alignItems:`center`,gap:`0.35rem 0.9rem`,border:`1px solid rgba(128,128,128,0.28)`,borderRadius:`0.5rem`,padding:`0.45rem 0.75rem`,margin:`0 0 1.25rem`,fontSize:`0.875rem`},children:[_jsx(`span`,{style:{fontWeight:600},children:`Available in`}),_jsx(`span`,{children:`🇮🇳 India`}),_jsx(`span`,{children:`🇲🇾 Malaysia`})]}),`\n`,_jsx(_components.p,{children:`Idempotency allows you to safely retry or send the same request multiple times without fear of repeating the normal refund request more than once.`}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`When you try to create a normal refund, in some cases due to network downtimes, you may not get a response from our servers. As a consequence, you will not be aware of the refund id or its state. In such cases, you can safely retry the transaction using the same idempotency key without risk of double-refund or duplication.`}),`\n`,_jsxs(_components.li,{children:[`To make a normal refund request idempotent, add the header `,_jsx(_components.code,{children:`X-Refund-Idempotency`}),` to the request and pass an idempotency key against it. The idempotency key must be at least 10 character long and can contain alphabets, numbers, hyphens and underscores only. For example, `,_jsx(_components.code,{children:`550e8400-e29b-41d4-a716-446655440000`}),`.`]}),`\n`,_jsx(_components.li,{children:`Idempotency is supported for both Normal and Instant Refunds APIs.`}),`\n`]}),`\n`,_jsxs(Info,{children:[_jsx(_components.p,{children:_jsx(_components.strong,{children:`Handy Tips`})}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`When retrying a request, the request body must be the same as the first request for idempotency to work. A different payload will be rejected as a `,_jsx(_components.code,{children:`BAD_REQUEST`}),`.`]}),`\n`,_jsx(_components.li,{children:`The idempotency key in retries must be the same as the original request.`}),`\n`,_jsx(_components.li,{children:`Use unique idempotency keys for each unique request.`}),`\n`,_jsx(_components.li,{children:`If a request is received while a prior request is still being processed, the system will return a 409 Conflict status code. You may retry the request upon receiving this response.`}),`\n`]})]}),`\n`,_jsxs(RequestExample,{children:[_jsx(CodeBlock,{filename:`Curl`,numberOfLines:`7`,language:`shellscript`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`shellscript`,children:_jsxs(_components.code,{language:`shellscript`,numberOfLines:`7`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#953800`,\"--shiki-dark\":`#DCDCAA`},children:`curl`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` -u`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` [YOUR_KEY_ID]:[YOUR_KEY_SECRET] `}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D7BA7D`},children:`\\\\`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#953800`,\"--shiki-dark\":`#DCDCAA`},children:`-X`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` POST`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` https://api.razorpay.com/v1/payments/pay_29QQoUBi66xm2f/refund`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D7BA7D`},children:` \\\\`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`-H `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`'Content-Type: application/json'`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D7BA7D`},children:` \\\\`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`-H `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`'X-Refund-Idempotency: 550e8400-e29b-41d4-a716-446655440000'`}),_jsx(_components.span,{style:{color:`#CF222E`,\"--shiki-dark\":`#D7BA7D`},children:` \\\\`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`-d `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`'{`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` \"amount\": 500100`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`}'`})}),`\n`]})})}),_jsx(CodeBlock,{filename:`CLI`,numberOfLines:`1`,language:`shellscript`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`shellscript`,children:_jsxs(_components.code,{language:`shellscript`,numberOfLines:`1`,children:[_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#953800`,\"--shiki-dark\":`#DCDCAA`},children:`razorpay`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` refunds`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` create`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` pay_ABC123`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` --amount`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:` 500100`}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:` --idempotency-key`}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:` 550e8400-e29b-41d4-a716-446655440000`})]}),`\n`]})})})]}),`\n`,_jsxs(ResponseExample,{children:[_jsx(CodeBlock,{filename:`Success`,numberOfLines:`17`,language:`json`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`json`,children:_jsxs(_components.code,{language:`json`,numberOfLines:`17`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`{`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"id\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"rfnd_FP8QHiV938haTz\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"entity\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"refund\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"amount\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:`500100`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"receipt\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"Receipt No. 31\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"currency\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"INR\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"payment_id\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"pay_29QQoUBi66xm2f\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"notes\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: {},`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"acquirer_data\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: {`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"arn\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:`null`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` },`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"created_at\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#B5CEA8`},children:`1597078866`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"batch_id\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0550AE`,\"--shiki-dark\":`#569CD6`},children:`null`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"status\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"processed\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"speed_processed\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"normal\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"speed_requested\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"normal\"`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`}`})}),`\n`]})})}),_jsx(CodeBlock,{filename:`Failure`,numberOfLines:`10`,language:`json`,children:_jsx(_components.pre,{className:`shiki shiki-themes github-light-default dark-plus`,style:{backgroundColor:`#ffffff`,\"--shiki-dark-bg\":`#0B0C0E`,color:`#1f2328`,\"--shiki-dark\":`#D4D4D4`},language:`json`,children:_jsxs(_components.code,{language:`json`,numberOfLines:`10`,children:[_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`{`})}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"error\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: {`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"code\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"BAD_REQUEST_ERROR\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"description\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"Different request with the same idempotency key has already been processed.\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"source\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"NA\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"step\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"NA\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"reason\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: `}),_jsx(_components.span,{style:{color:`#0A3069`,\"--shiki-dark\":`#CE9178`},children:`\"NA\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`,`})]}),`\n`,_jsxs(_components.span,{className:`line`,children:[_jsx(_components.span,{style:{color:`#116329`,\"--shiki-dark\":`#9CDCFE`},children:` \"metadata\"`}),_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`: {}`})]}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:` }`})}),`\n`,_jsx(_components.span,{className:`line`,children:_jsx(_components.span,{style:{color:`#1F2328`,\"--shiki-dark\":`#D4D4D4`},children:`}`})}),`\n`]})})})]}),`\n`,_jsx(Heading,{level:`2`,id:`path-parameters`,children:`Path Parameters`}),`\n`,_jsx(ParamField,{path:`id`,type:`string`,required:true,id:`param-id`,children:_jsx(_components.p,{children:`The unique identifier of the payment which needs to be refunded.`})}),`\n`,_jsx(Heading,{level:`2`,id:`request-parameters`,children:`Request Parameters`}),`\n`,_jsxs(ParamField,{body:`amount`,type:`integer`,id:`param-amount`,children:[_jsxs(_components.p,{children:[`The amount to be refunded. Amount should be in the smallest unit of the currency in which the payment was made. In the case of three decimal currencies, such as KWD, BHD and OMR, to refund a payment of 295.991, pass the value as `,_jsx(_components.code,{children:`295990`}),`. And in the case of zero decimal currencies such as JPY, to refund a payment of 295, pass the value as `,_jsx(_components.code,{children:`295`}),`.`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`For a `,_jsx(_components.strong,{children:`partial refund`}),`, enter a value lesser than the payment amount. For example, if the payment amount is ₹1500 and you want to refund only ₹500, you must pass `,_jsx(_components.code,{children:`50000`}),`.`]}),`\n`,_jsxs(_components.li,{children:[`For `,_jsx(_components.strong,{children:`full refund`}),`, enter the entire payment amount. If the `,_jsx(_components.code,{children:`amount`}),` parameter is not passed, the entire payment amount will be refunded.`]}),`\n`]}),_jsxs(Warning,{children:[_jsx(_components.p,{children:_jsx(_components.strong,{children:`Watch Out!`})}),_jsxs(_components.p,{children:[`As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to refund a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as `,_jsx(_components.code,{children:`99990`}),` and not `,_jsx(_components.code,{children:`99991`}),`.`]})]})]}),`\n`,_jsx(ParamField,{body:`speed`,type:`string`,id:`param-speed`,children:_jsxs(_components.p,{children:[`The speed at which the refund is to be processed. The default value is `,_jsx(_components.code,{children:`normal`}),`. Refund will be processed via the normal speed, and the customer will receive the refund within 5-7 working days.`]})}),`\n`,_jsx(ParamField,{body:`notes`,type:`json object`,id:`param-notes`,children:_jsx(_components.p,{children:`Key-value pairs used to store additional information. A maximum of 15 key-value pairs can be included.`})}),`\n`,_jsx(ParamField,{body:`receipt`,type:`string`,id:`param-receipt`,children:_jsx(_components.p,{children:`A unique identifier provided by you for your internal reference.`})}),`\n`,_jsx(Heading,{level:`2`,id:`response-parameters`,children:`Response Parameters`}),`\n`,_jsx(ResponseField,{name:`id`,type:`string`,id:`param-id-1`,children:_jsxs(_components.p,{children:[`The unique identifier of the refund. For example, `,_jsx(_components.code,{children:`rfnd_FgRAHdNOM4ZVbO`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`entity`,type:`string`,id:`param-entity`,children:_jsxs(_components.p,{children:[`Indicates the type of entity. Here, it is `,_jsx(_components.code,{children:`refund`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`amount`,type:`integer`,id:`param-amount-1`,children:_jsxs(_components.p,{children:[`The amount to be refunded (in the smallest unit of currency). `,_jsx(`br`,{}),` For example, if the refund value is ₹30 it will be `,_jsx(_components.code,{children:`3000`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`currency`,type:`string`,id:`param-currency`,children:_jsxs(_components.p,{children:[`The currency of payment amount for which the refund is initiated. Check the list of `,_jsx(_components.a,{href:`/payments/international-payments#supported-currencies`,children:`supported currencies`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`payment_id`,type:`string`,id:`param-payment-id`,children:_jsxs(_components.p,{children:[`The unique identifier of the payment for which a refund is initiated. For example, `,_jsx(_components.code,{children:`pay_FgR9UMzgmKDJRi`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`created_at`,type:`integer`,id:`param-created-at`,children:_jsxs(_components.p,{children:[`Unix timestamp at which the refund was created. For example, `,_jsx(_components.code,{children:`1600856650`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`batch_id`,type:`string`,id:`param-batch-id`,children:_jsxs(_components.p,{children:[`This parameter is populated if the refund was created as part of a batch upload. For example, `,_jsx(_components.code,{children:`batch_00000000000001`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`notes`,type:`json object`,id:`param-notes-1`,children:_jsxs(_components.p,{children:[`Key-value store for storing your reference data. A maximum of 15 key-value pairs can be included. For example, `,_jsx(_components.code,{children:`\"note_key\": \"Beam me up Scotty\"`}),`.`]})}),`\n`,_jsx(ResponseField,{name:`receipt`,type:`string`,id:`param-receipt-1`,children:_jsx(_components.p,{children:`A unique identifier provided by you for your internal reference.`})}),`\n`,_jsx(ResponseField,{name:`acquirer_data`,type:`array`,id:`param-acquirer-data`,children:_jsx(_components.p,{children:`A dynamic array consisting of a unique reference number (either RRN, ARN or UTR) that is provided by the banking partner when a refund is processed. This reference number can be used by the customer to track the status of the refund with the bank.`})}),`\n`,_jsxs(ResponseField,{name:`status`,type:`string`,id:`param-status`,children:[_jsx(_components.p,{children:`Indicates the state of the refund. Possible values:`}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`pending`}),`: This state indicates that Razorpay is attempting to process the refund.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`processed`}),`: This is the final state of the refund.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`failed`}),`: A refund can attain the failed state in the following scenarios:`,_jsx(`br`,{}),`\n`,_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`Normal refund is not possible for a payment which is more than 6 months old.`,_jsx(`br`,{})]}),`\n`,_jsx(_components.li,{children:`Instant Refund can sometimes fail because of customer’s account or bank-related issues.`}),`\n`]}),`\n`]}),`\n`]})]}),`\n`,_jsxs(ResponseField,{name:`speed_requested`,type:`string`,id:`param-speed-requested`,children:[_jsxs(_components.p,{children:[`The processing mode of the refund seen in the refund response. `,_jsx(`br`,{}),` This attribute is seen in the refund response only if the `,_jsx(_components.code,{children:`speed`}),` parameter is set in the refund request.`,_jsx(`br`,{}),`Possible values:`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`normal`}),`: Indicates that the refund will be processed via the normal speed. The refund will take 5-7 working days.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`optimum`}),`: Indicates that the refund will be processed at an optimal speed based on Razorpay’s internal fund transfer logic.`,`\n`,_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`If the refund can be processed instantly, Razorpay will do so, irrespective of the payment method used to make the payment.`}),`\n`,_jsx(_components.li,{children:`If an instant refund is not possible, Razorpay will initiate a refund that is processed at the normal speed.`}),`\n`]}),`\n`]}),`\n`]})]}),`\n`,_jsxs(ResponseField,{name:`speed_processed`,type:`string`,id:`param-speed-processed`,children:[_jsxs(_components.p,{children:[`This is a parameter in the response which describes the mode used to process a refund. `,_jsx(`br`,{}),` This attribute is seen in the refund response only if the `,_jsx(_components.code,{children:`speed`}),` parameter is set in the refund request. Possible values:`]}),_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`instant`}),`: Indicates that the refund has been processed instantly via fund transfer.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.code,{children:`normal`}),`: Indicates that the refund has been processed by the payment processing partner. The refund will take 5-7 working days.`]}),`\n`]})]}),`\n`,_jsx(Heading,{level:`2`,id:`errors`,children:`Errors`}),`\n`,_jsxs(AccordionGroup,{children:[_jsxs(Accordion,{title:`The API {key/secret} provided is invalid.`,id:`the-api-key-secret-provided-is-invalid`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`4xx`})]}),_jsx(_components.p,{children:`The API credentials passed in the API call differ from the ones generated on the Dashboard.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` The API keys must be active and entered correctly with no whitespace before or after.`]})]}),_jsxs(Accordion,{title:`{Payment_id} is not a valid id.`,id:`payment-id-is-not-a-valid-id`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsxs(_components.p,{children:[`The `,_jsx(_components.code,{children:`payment_id`}),` provided is invalid.`]}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use a valid `,_jsx(_components.code,{children:`payment_id`}),`.`]})]}),_jsxs(Accordion,{title:`The requested URL was not found on the server.`,id:`the-requested-url-was-not-found-on-the-server`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`Possible reasons:`}),_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`The URL is wrong or is missing something.`}),`\n`,_jsx(_components.li,{children:`A POST API is executed by GET method.`}),`\n`]}),_jsx(_components.p,{children:_jsx(_components.strong,{children:`Solution:`})}),_jsxs(_components.ul,{children:[`\n`,_jsx(_components.li,{children:`Ensure that the URL is correct and complete.`}),`\n`,_jsx(_components.li,{children:`Use the correct method, that is, POST.`}),`\n`]})]}),_jsxs(Accordion,{title:`{any Extra field} is/are not required and should not be sent.`,id:`any-extra-field-is-are-not-required-and-should-not-be-sent`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`An additional or unrequired parameter is passed.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure that you only pass the required parameters in the request body.`]})]}),_jsxs(Accordion,{title:`The refund amount provided is greater than amount captured.`,id:`the-refund-amount-provided-is-greater-than-amount-captured`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The refund amount entered is more than the amount captured.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Enter an amount equal to or less than the amount captured.`]})]}),_jsxs(Accordion,{title:_jsx(_Fragment,{children:`The amount must be at least INR 1.00.`}),id:`the-amount-must-be-at-least-inr-1-00`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The refund amount entered is less than .`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Enter an amount of at least .`]})]}),_jsxs(Accordion,{title:`The payment has been fully refunded already.`,id:`the-payment-has-been-fully-refunded-already`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsxs(_components.p,{children:[`The `,_jsx(_components.code,{children:`payment_id`}),` has already been refunded fully.`]}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use a `,_jsx(_components.code,{children:`payment_id`}),` that has not been fully refunded.`]})]}),_jsxs(Accordion,{title:`Different request with the same idempotency key has already been processed.`,id:`different-request-with-the-same-idempotency-key-has-already-been-processed`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`409`})]}),_jsx(_components.p,{children:`Another refund request with different parameters has been processed using the same idempotency key.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use a unique idempotency key for the new request and retry.`]})]}),_jsxs(Accordion,{title:`Another request with the same idempotency key is still in progress.`,id:`another-request-with-the-same-idempotency-key-is-still-in-progress`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`409`})]}),_jsx(_components.p,{children:`A refund request with the same idempotency key is currently being processed and has not yet returned a response.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Wait for the previous request to complete or use a different idempotency key.`]})]}),_jsxs(Accordion,{title:`Internal server error - Failed to fetch idempotency record`,id:`internal-server-error-failed-to-fetch-idempotency-record`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`500`})]}),_jsx(_components.p,{children:`The server encountered an error while retrieving the idempotency record.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Retry the request after some time. If the issue persists, contact `,_jsx(_components.a,{href:`https://razorpay.com/support`,children:`Razorpay Support`}),`.`]})]}),_jsxs(Accordion,{title:`Internal server error - Failed to parse request body`,id:`internal-server-error-failed-to-parse-request-body`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`500`})]}),_jsx(_components.p,{children:`The server failed to parse the request body to generate the request hash.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure the request body is properly formatted as valid JSON. If the issue persists, contact `,_jsx(_components.a,{href:`https://razorpay.com/support`,children:`Razorpay Support`}),`.`]})]}),_jsxs(Accordion,{title:`The idempotency key must be at least 10 characters long.`,id:`the-idempotency-key-must-be-at-least-10-characters-long`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The idempotency key provided is less than 10 characters in length.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Use an idempotency key that is at least 10 characters long.`]})]}),_jsxs(Accordion,{title:`The idempotency key must only contain alphanumeric characters, underscores, and hyphens`,id:`the-idempotency-key-must-only-contain-alphanumeric-characters-underscores-and-hyphens`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`400`})]}),_jsx(_components.p,{children:`The idempotency key contains invalid special characters.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure the idempotency key only contains alphanumeric characters (A-Z, a-z, 0-9), underscores (_), and hyphens (-).`]})]}),_jsxs(Accordion,{title:`Merchant id not found in authentication`,id:`merchant-id-not-found-in-authentication`,children:[_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Code:`}),` `,_jsx(_components.code,{children:`500`})]}),_jsx(_components.p,{children:`The request contains an idempotency key but the merchant authentication is invalid or missing.`}),_jsxs(_components.p,{children:[_jsx(_components.strong,{children:`Solution:`}),` Ensure you are using valid API credentials (Key ID and Key Secret) for authentication. If the issue persists, contact `,_jsx(_components.a,{href:`https://razorpay.com/support`,children:`Razorpay Support`}),`.`]})]})]})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Create a Normal Refund (Idempotent Request)","description":"Retry or send the same normal refund request multiple times safely using the Razorpay API.","api":"POST /v1/payments/:id/refund","href":"/api/refunds/normal-refunds-idempotent"}}}},"mdxExtracts":{"tableOfContents":[{"title":"Path Parameters","slug":"path-parameters","depth":2,"children":[]},{"title":"Request Parameters","slug":"request-parameters","depth":2,"children":[]},{"title":"Response Parameters","slug":"response-parameters","depth":2,"children":[]},{"title":"Errors","slug":"errors","depth":2,"children":[]}],"codeExamples":{"request":{"type":"RequestExample","children":[{"filename":"Curl","html":"\u003cpre class=\"shiki shiki-themes github-light-default dark-plus\" style=\"background-color:#ffffff;--shiki-dark-bg:#0B0C0E;color:#1f2328;--shiki-dark:#D4D4D4\" language=\"shellscript\">\u003ccode language=\"shellscript\" numberOfLines=\"7\">\u003cspan class=\"line\">\u003cspan style=\"color:#953800;--shiki-dark:#DCDCAA\">curl\u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#569CD6\"> -u\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\"> [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \u003c/span>\u003cspan style=\"color:#CF222E;--shiki-dark:#D7BA7D\">\\\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#953800;--shiki-dark:#DCDCAA\">-X\u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> POST\u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> https://api.razorpay.com/v1/payments/pay_29QQoUBi66xm2f/refund\u003c/span>\u003cspan style=\"color:#CF222E;--shiki-dark:#D7BA7D\"> \\\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">-H \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">'Content-Type: application/json'\u003c/span>\u003cspan style=\"color:#CF222E;--shiki-dark:#D7BA7D\"> \\\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">-H \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">'X-Refund-Idempotency: 550e8400-e29b-41d4-a716-446655440000'\u003c/span>\u003cspan style=\"color:#CF222E;--shiki-dark:#D7BA7D\"> \\\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">-d \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">'{\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> \"amount\": 500100\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">}'\u003c/span>\u003c/span>\n\u003c/code>\u003c/pre>"},{"filename":"CLI","html":"\u003cpre class=\"shiki shiki-themes github-light-default dark-plus\" style=\"background-color:#ffffff;--shiki-dark-bg:#0B0C0E;color:#1f2328;--shiki-dark:#D4D4D4\" language=\"shellscript\">\u003ccode language=\"shellscript\" numberOfLines=\"1\">\u003cspan class=\"line\">\u003cspan style=\"color:#953800;--shiki-dark:#DCDCAA\">razorpay\u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> refunds\u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> create\u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> pay_ABC123\u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#569CD6\"> --amount\u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#B5CEA8\"> 500100\u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#569CD6\"> --idempotency-key\u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\"> 550e8400-e29b-41d4-a716-446655440000\u003c/span>\u003c/span>\n\u003c/code>\u003c/pre>"}],"attributes":[]},"response":{"type":"ResponseExample","children":[{"filename":"Success","html":"\u003cpre class=\"shiki shiki-themes github-light-default dark-plus\" style=\"background-color:#ffffff;--shiki-dark-bg:#0B0C0E;color:#1f2328;--shiki-dark:#D4D4D4\" language=\"json\">\u003ccode language=\"json\" numberOfLines=\"17\">\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">{\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"id\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"rfnd_FP8QHiV938haTz\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"entity\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"refund\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"amount\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#B5CEA8\">500100\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"receipt\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"Receipt No. 31\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"currency\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"INR\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"payment_id\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"pay_29QQoUBi66xm2f\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"notes\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: {},\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"acquirer_data\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: {\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"arn\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#569CD6\">null\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\"> },\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"created_at\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#B5CEA8\">1597078866\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"batch_id\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0550AE;--shiki-dark:#569CD6\">null\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"status\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"processed\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"speed_processed\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"normal\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"speed_requested\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"normal\"\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">}\u003c/span>\u003c/span>\n\u003c/code>\u003c/pre>"},{"filename":"Failure","html":"\u003cpre class=\"shiki shiki-themes github-light-default dark-plus\" style=\"background-color:#ffffff;--shiki-dark-bg:#0B0C0E;color:#1f2328;--shiki-dark:#D4D4D4\" language=\"json\">\u003ccode language=\"json\" numberOfLines=\"10\">\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">{\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"error\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: {\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"code\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"BAD_REQUEST_ERROR\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"description\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"Different request with the same idempotency key has already been processed.\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"source\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"NA\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"step\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"NA\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"reason\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: \u003c/span>\u003cspan style=\"color:#0A3069;--shiki-dark:#CE9178\">\"NA\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">,\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#116329;--shiki-dark:#9CDCFE\"> \"metadata\"\u003c/span>\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">: {}\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\"> }\u003c/span>\u003c/span>\n\u003cspan class=\"line\">\u003cspan style=\"color:#1F2328;--shiki-dark:#D4D4D4\">}\u003c/span>\u003c/span>\n\u003c/code>\u003c/pre>"}],"attributes":[]}},"endpoint":{"title":"Create a Normal Refund (Idempotent Request)","path":"/v1/payments/:id/refund","servers":[{"url":"https://api.razorpay.com"}],"method":"post","request":{"security":[{"title":"Basic Auth","parameters":{"header":{"Authorization":{"type":"http","scheme":"basic","description":"Basic authentication header of the form `Basic \u003cencoded-value>`, where `\u003cencoded-value>` is the base64-encoded string `username:password`."}},"query":{},"cookie":{}}}],"parameters":{"query":{},"header":{},"cookie":{},"path":{"id":{"schema":[{"type":"string","description":"The unique identifier of the payment which needs to be refunded.","required":true}]}}},"body":{"application/json":{"schemaArray":[{"type":"object","properties":{"amount":[{"type":"integer","description":"The amount to be refunded. Amount should be in the smallest unit of the currency in which the payment was made. In the case of three decimal currencies, such as KWD, BHD and OMR, to refund a payment of 295.991, pass the value as `295990` . And in the case of zero decimal currencies such as JPY, to refund a payment of 295, pass the value as `295` . For a partial refund , enter a value lesser than the payment amount. For example, if the payment amount is ₹1500 and you want to refund only ₹500, you must pass `50000` . For full refund , enter the entire payment amount. If the `amount` parameter is not passed, the entire payment amount will be refunded."}],"speed":[{"type":"string","description":"The speed at which the refund is to be processed. The default value is `normal` . Refund will be processed via the normal speed, and the customer will receive the refund within 5-7 working days."}],"notes":[{"type":"object","properties":{},"description":"Key-value pairs used to store additional information. A maximum of 15 key-value pairs can be included."}],"receipt":[{"type":"string","description":"A unique identifier provided by you for your internal reference."}]}}],"examples":{"example":{"value":{"amount":123,"speed":"\u003cstring>","notes":{},"receipt":"\u003cstring>"}}}}}},"response":{"200":{"application/json":{"schemaArray":[{"type":"object","properties":{"id":[{"type":"string","description":"The unique identifier of the refund. For example, `rfnd_FgRAHdNOM4ZVbO` ."}],"entity":[{"type":"string","description":"Indicates the type of entity. Here, it is `refund` ."}],"amount":[{"type":"integer","description":"The amount to be refunded (in the smallest unit of currency). For example, if the refund value is ₹30 it will be `3000` ."}],"currency":[{"type":"string","description":"The currency of payment amount for which the refund is initiated. Check the list of supported currencies ."}],"payment_id":[{"type":"string","description":"The unique identifier of the payment for which a refund is initiated. For example, `pay_FgR9UMzgmKDJRi` ."}],"created_at":[{"type":"integer","description":"Unix timestamp at which the refund was created. For example, `1600856650` ."}],"batch_id":[{"type":"string","description":"This parameter is populated if the refund was created as part of a batch upload. For example, `batch_00000000000001` ."}],"notes":[{"type":"object","properties":{},"description":"Key-value store for storing your reference data. A maximum of 15 key-value pairs can be included. For example, `\"note_key\": \"Beam me up Scotty\"` ."}],"receipt":[{"type":"string","description":"A unique identifier provided by you for your internal reference."}],"acquirer_data":[{"type":"array","items":[{"type":"object","properties":{}}],"description":"A dynamic array consisting of a unique reference number (either RRN, ARN or UTR) that is provided by the banking partner when a refund is processed. This reference number can be used by the customer to track the status of the refund with the bank."}],"status":[{"type":"string","description":"Indicates the state of the refund. Possible values: `pending` : This state indicates that Razorpay is attempting to process the refund. `processed` : This is the final state of the refund. `failed` : A refund can attain the failed state in the following scenarios: Normal refund is not possible for a payment which is more than 6 months old. Instant Refund can sometimes fail because of customer’s account or bank-related issues."}],"speed_requested":[{"type":"string","description":"The processing mode of the refund seen in the refund response. This attribute is seen in the refund response only if the `speed` parameter is set in the refund request. Possible values: `normal` : Indicates that the refund will be processed via the normal speed. The refund will take 5-7 working days. `optimum` : Indicates that the refund will be processed at an optimal speed based on Razorpay’s internal fund transfer logic. If the refund can be processed instantly, Razorpay will do so, irrespective of the payment method used to make the payment. If an instant refund is not possible, Razorpay will initiate a refund that is processed at the normal speed."}],"speed_processed":[{"type":"string","description":"This is a parameter in the response which describes the mode used to process a refund. This attribute is seen in the refund response only if the `speed` parameter is set in the refund request. Possible values: `instant` : Indicates that the refund has been processed instantly via fund transfer. `normal` : Indicates that the refund has been processed by the payment processing partner. The refund will take 5-7 working days."}]}}],"examples":{"example":{"value":{"id":"\u003cstring>","entity":"\u003cstring>","amount":123,"currency":"\u003cstring>","payment_id":"\u003cstring>","created_at":123,"batch_id":"\u003cstring>","notes":{},"receipt":"\u003cstring>","acquirer_data":[{}],"status":"\u003cstring>","speed_requested":"\u003cstring>","speed_processed":"\u003cstring>"}}}}}},"deprecated":false}},"jsLinks":["/docs/_mintlify/custom/razorpay-881012b3/ccee8c0e9edccd6b/country-switcher.js","/docs/_mintlify/custom/razorpay-881012b3/ccb1482537a84031/static/docs-home/script.js","/docs/_mintlify/custom/razorpay-881012b3/e78183bdfe89167a/ga4.js"],"subdomain":"razorpay-881012b3","siteName":"Razorpay","title":"Create a Normal Refund (Idempotent Request) - Razorpay","navMaps":{"firstHrefInVersion":{"India":{"href":"/api/refunds/normal-refunds-idempotent","matchLevel":0},"Singapore":{"href":"/sg/home","matchLevel":4},"United States":{"href":"/us/home","matchLevel":4}},"firstHrefInLanguage":{}},"lastModified":"2026-10-08T16:37:53.942Z","originalFileLocation":"api/refunds/normal-refunds-idempotent.mdx"},"headHtml":"\u003cscript data-mint-head>(function(){var d=document.documentElement,p=null;if(!p){try{p=localStorage.getItem(\"isDarkMode\")}catch(e){}if(p==='true')p='dark';else if(p==='false')p='light';if(p!=='light'\u0026\u0026p!=='dark'\u0026\u0026p!=='system')p=\"system\"}var r=p==='system'?(matchMedia(\"(prefers-color-scheme: dark)\").matches?'dark':'light'):p;d.classList.remove(r==='dark'?'light':'dark');d.classList.add(r);d.setAttribute(\"data-theme-preference\",p)})();\u003c/script>\u003cmeta data-mint-head name=\"description\" content=\"Retry or send the same normal refund request multiple times safely using the Razorpay API.\">\u003cmeta data-mint-head name=\"application-name\" content=\"Razorpay\">\u003cmeta data-mint-head name=\"generator\" content=\"Mintlify\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon/android-chrome-192x192.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"apple-touch-icon\" type=\"image/png\" sizes=\"180x180\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon/apple-touch-icon.png\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon/favicon-16x16.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon/favicon-32x32.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon/favicon.ico\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon-dark/android-chrome-192x192.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon-dark/favicon-16x16.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon-dark/favicon-32x32.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/docs/mintlify-assets/_mintlify/favicons/razorpay-881012b3/gWy2bjt_zV_OZ2iN/_generated/favicon-dark/favicon.ico\" media=\"(prefers-color-scheme: dark)\">\u003cmeta data-mint-head property=\"og:title\" content=\"Create a Normal Refund (Idempotent Request) - Razorpay\">\u003cmeta data-mint-head property=\"og:description\" content=\"Retry or send the same normal refund request multiple times safely using the Razorpay API.\">\u003cmeta data-mint-head property=\"og:site_name\" content=\"Razorpay\">\u003cmeta data-mint-head property=\"og:url\" content=\"https://razorpay.com/api/refunds/normal-refunds-idempotent\">\u003cmeta data-mint-head property=\"og:type\" content=\"website\">\u003cmeta data-mint-head property=\"og:image\" content=\"https://razorpay-881012b3.mintlify.app/_mintlify/api/og/v2?division=Refunds\u0026amp;title=Create+a+Normal+Refund+%28Idempotent+Request%29\u0026amp;description=Retry+or+send+the+same+normal+refund+request+multiple+times+safely+using+the+Razorpay+API.\u0026amp;theme=bb58a630b2bbead7dc77be4b\u0026amp;signature=05449ea4b821a1403a1b21c10115ea7997cdabf6a4a2e5955a6093603d34172e\">\u003cmeta data-mint-head property=\"og:image:width\" content=\"1200\">\u003cmeta data-mint-head property=\"og:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"twitter:card\" content=\"summary_large_image\">\u003cmeta data-mint-head name=\"twitter:title\" content=\"Create a Normal Refund (Idempotent Request) - Razorpay\">\u003cmeta data-mint-head name=\"twitter:description\" content=\"Retry or send the same normal refund request multiple times safely using the Razorpay API.\">\u003cmeta data-mint-head name=\"twitter:image\" content=\"https://razorpay-881012b3.mintlify.app/_mintlify/api/og/v2?division=Refunds\u0026amp;title=Create+a+Normal+Refund+%28Idempotent+Request%29\u0026amp;description=Retry+or+send+the+same+normal+refund+request+multiple+times+safely+using+the+Razorpay+API.\u0026amp;theme=bb58a630b2bbead7dc77be4b\u0026amp;signature=05449ea4b821a1403a1b21c10115ea7997cdabf6a4a2e5955a6093603d34172e\">\u003cmeta data-mint-head name=\"twitter:image:width\" content=\"1200\">\u003cmeta data-mint-head name=\"twitter:image:height\" content=\"630\">\u003cme
[...]
